#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <conio.h>
#include "astro.h"


static double Nut[106][10]={

{ 0, 0, 0, 0, 1, 6798.4,-171996, -174.2, 92025, 8.9},
{ 0, 0, 0, 0, 2, 3399.2,   2062,    0.2,  -895, 0.5},
{-2, 0, 2, 0, 1, 1305.5,     46,      0,   -24, 0  },
{ 2, 0,-2, 0, 0, 1095.2,     11,      0,     0, 0  },
{-2, 0, 2, 0, 2, 1615.7,     -3,      0,     1, 0  },
{ 1,-1, 0,-1, 0, 3232.9,     -3,      0,     0, 0  },
{ 0,-2, 2,-2, 1, 6786.3,     -2,      0,     1, 0  },
{ 2, 0,-2, 0, 1,  943.2,      1,      0,     0, 0  },
{ 0, 0, 2,-2, 2,  182.6, -13187,   -1.6,  5736,-3.1},
{ 0, 1, 0, 0, 0,  365.3,   1426,   -3.4,    54,-0.1},
{ 0, 1, 2,-2, 2,  121.7,   -517,    1.2,   224,-0.6},
{ 0,-1, 2,-2, 2,  365.2,    217,   -0.5,   -95, 0.3},
{ 0, 0, 2,-2, 1,  177.8,    129,    0.1,   -70, 0  },
{ 2, 0, 0,-2, 0,  205.9,     48,      0,     1, 0  },
{ 0, 0, 2,-2, 0,  173.3,    -22,      0,     0, 0  },
{ 0, 2, 0, 0, 0,  182.6,     17,   -0.1,     0, 0  },
{ 0, 1, 0, 0, 1,  386.0,    -15,      0,     9, 0  },
{ 0, 2, 2,-2, 2,   91.3,    -16,    0.1,     7, 0  },
{ 0,-1, 0, 0, 1,  346.6,    -12,      0,     6, 0  },
{-2, 0, 0, 2, 1,  199.8,     -6,      0,     3, 0  },
{ 0,-1, 2,-2, 1,  346.6,     -5,      0,     3, 0  },
{ 2, 0, 0,-2, 1,  212.3,      4,      0,    -2, 0  },
{ 0, 1, 2,-2, 1,  119.6,      4,      0,    -2, 0  },
{ 1, 0, 0,-1, 0,  411.8,     -4,      0,     0, 0  },
{ 2, 1, 0,-2, 0,  131.7,      1,      0,     0, 0  },
{ 0, 0,-2, 2, 1,  169.0,      1,      0,     0, 0  },
{ 0, 1,-2, 2, 0,  329.8,     -1,      0,     0, 0  },
{ 0, 1, 0, 0, 2,  409.2,      1,      0,     0, 0  },
{-1, 0, 0, 1, 1,  388.3,      1,      0,     0, 0  },
{ 0, 1, 2,-2, 0,  117.5,     -1,      0,     0, 0  },
{ 0, 0, 2, 0, 2,   13.7,  -2274,   -0.2,   977,-0.5},
{ 1, 0, 0, 0, 0,   27.6,    712,    0.1,    -7, 0  },
{ 0, 0, 2, 0, 1,   13.6,   -386,   -0.4,   200, 0  },
{ 1, 0, 2, 0, 2,    9.1,   -301,      0,   129,-0.1},
{ 1, 0, 0,-2, 0,   31.8,   -158,      0,    -1, 0  },
{-1, 0, 2, 0, 2,   27.1,    123,      0,   -53, 0  },
{ 0, 0, 0, 2, 0,   14.8,     63,      0,    -2, 0  },
{ 1, 0, 0, 0, 1,   27.7,     63,    0.1,   -33, 0  },
{-1, 0, 0, 0, 1,   27.4,    -58,   -0.1,    32, 0  },
{-1, 0, 2, 2, 2,    9.6,    -59,      0,    26, 0  },
{ 1, 0, 2, 0, 1,    9.1,    -51,      0,    27, 0  },
{ 0, 0, 2, 2, 2,    7.1,    -38,      0,    16, 0  },
{ 2, 0, 0, 0, 0,   13.8,     29,      0,    -1, 0  },
{ 1, 0, 2,-2, 2,   23.9,     29,      0,   -12, 0  },
{ 2, 0, 2, 0, 2,    6.9,    -31,      0,    13, 0  },
{ 0, 0, 2, 0, 0,   13.6,     26,      0,    -1, 0  },
{-1, 0, 2, 0, 1,   27.0,     21,      0,   -10, 0  },
{-1, 0, 0, 2, 1,   32.0,     16,      0,    -8, 0  },
{ 1, 0, 0,-2, 1,   31.7,    -13,      0,     7, 0  },
{-1, 0, 2, 2, 1,    9.5,    -10,      0,     5, 0  },
{ 1, 1, 0,-2, 0,   34.8,     -7,      0,     0, 0  },
{ 0, 1, 2, 0, 2,   13.2,      7,      0,    -3, 0  },
{ 0,-1, 2, 0, 2,   14.2,     -7,      0,     3, 0  },
{ 1, 0, 2, 2, 2,    5.6,     -8,      0,     3, 0  },
{ 1, 0, 0, 2, 0,    9.6,      6,      0,     0, 0  },
{ 2, 0, 2,-2, 2,   12.8,      6,      0,    -3, 0  },
{ 0, 0, 0, 2, 1,   14.8,     -6,      0,     3, 0  },
{ 0, 0, 2, 2, 1,    7.1,     -7,      0,     3, 0  },
{ 1, 0, 2,-2, 1,   23.9,      6,      0,    -3, 0  },
{ 0, 0, 0,-2, 1,   14.7,     -5,      0,     3, 0  },
{ 1,-1, 0, 0, 0,   29.8,      5,      0,     0, 0  },
{ 2, 0, 2, 0, 1,    6.9,     -5,      0,     3, 0  },
{ 0, 1, 0,-2, 0,   15.4,     -4,      0,     0, 0  },
{ 1, 0,-2, 0, 0,   26.9,      4,      0,     0, 0  },
{ 0, 0, 0, 1, 0,   29.5,     -4,      0,     0, 0  },
{ 1, 1, 0, 0, 0,   25.6,     -3,      0,     0, 0  },
{ 1, 0, 2, 0, 0,    9.1,      3,      0,     0, 0  },
{ 1,-1, 2, 0, 2,    9.4,     -3,      0,     1, 0  },
{-1,-1, 2, 2, 2,    9.8,     -3,      0,     1, 0  },
{-2, 0, 0, 0, 1,   13.7,     -2,      0,     1, 0  },
{ 3, 0, 2, 0, 2,    5.5,     -3,      0,     1, 0  },
{ 0,-1, 2, 2, 2,    7.2,     -3,      0,     1, 0  },
{ 1, 1, 2, 0, 2,    8.9,      2,      0,    -1, 0  },
{-1, 0, 2,-2, 1,   32.6,     -2,      0,     1, 0  },
{ 2, 0, 0, 0, 1,   13.8,      2,      0,    -1, 0  },
{ 1, 0, 0, 0, 2,   27.8,     -2,      0,     1, 0  },
{ 3, 0, 0, 0, 0,    9.2,      2,      0,     0, 0  },
{ 0, 0, 2, 1, 2,    9.3,      2,      0,    -1, 0  },
{-1, 0, 0, 0, 2,   27.3,      1,      0,    -1, 0  },
{ 1, 0, 0,-4, 0,   10.1,     -1,      0,     0, 0  },
{-2, 0, 2, 2, 2,   14.6,      1,      0,    -1, 0  },
{-1, 0, 2, 4, 2,    5.8,     -2,      0,     1, 0  },
{ 2, 0, 0,-4, 0,   15.9,     -1,      0,     0, 0  },
{ 1, 1, 2,-2, 2,   22.5,      1,      0,    -1, 0  },
{ 1, 0, 2, 2, 1,    5.6,     -1,      0,     1, 0  },
{-2, 0, 2, 4, 2,    7.3,     -1,      0,     1, 0  },
{-1, 0, 4, 0, 2,    9.1,      1,      0,     0, 0  },
{ 1,-1, 0,-2, 0,   29.3,      1,      0,     0, 0  },
{ 2, 0, 2,-2, 1,   12.8,      1,      0,    -1, 0  },
{ 2, 0, 2, 2, 2,    4.7,     -1,      0,     0, 0  },
{ 1, 0, 0, 2, 1,    9.6,     -1,      0,     0, 0  },
{ 0, 0, 4,-2, 2,   12.7,      1,      0,     0, 0  },
{ 3, 0, 2,-2, 2,    8.7,      1,      0,     0, 0  },
{ 1, 0, 2,-2, 0,   23.8,     -1,      0,     0, 0  },
{ 0, 1, 2, 0, 1,   13.1,      1,      0,     0, 0  },
{-1,-1, 0, 2, 1,   35.0,      1,      0,     0, 0  },
{ 0, 0,-2, 0, 1,   13.6,     -1,      0,     0, 0  },
{ 0, 0, 2,-1, 2,   25.4,     -1,      0,     0, 0  },
{ 0, 1, 0, 2, 0,   14.2,     -1,      0,     0, 0  },
{ 1, 0,-2,-2, 0,    9.5,     -1,      0,     0, 0  },
{ 0,-1, 2, 0, 1,   14.2,     -1,      0,     0, 0  },
{ 1, 1, 0,-2, 1,   34.7,     -1,      0,     0, 0  },
{ 1, 0,-2, 2, 0,   32.8,     -1,      0,     0, 0  },
{ 2, 0, 0, 2, 0,    7.2,      1,      0,     0, 0  },
{ 0, 0, 2, 4, 2,    4.8,     -1,      0,     0, 0  },
{ 0, 1, 0, 1, 0,   27.3,      1,      0,     0, 0  }};

static double dNut[4][10]={

{ 0, 0, 0, 0, 1, 6798.4,   -725,    417,   213, 224},
{ 0, 1, 0, 0, 0,  365.3,    523,     61,   208, -24},
{ 0, 0, 2,-2, 2,  182.6,    102,   -118,   -41, -47},
{ 0, 0, 2, 0, 2,   13.7,    -81,      0,    32, 0  }};

void Nutation_data(double jd,double *dF, double *dE)
{
	double L,Ld,F,D,Omg,Arg,t;
	int i;

	t=T_2000 (jd);
	L=    134.962981389 + 477198.867398056*t + 0.008697222*t*t + 1.0/ 56250.0*t*t*t;
	Ld=   357.527723333 +  35999.050340000*t - 0.000160278*t*t - 1.0/300000.0*t*t*t;
	F=     93.271910278 + 483202.017538056*t - 0.003682500*t*t + 1.0/ 56250.0*t*t*t;
	D=    297.850363056 + 445267.111480000*t - 0.001914167*t*t + 1.0/189474.0*t*t*t;
	Omg=  125.044522222 -   1934.136260833*t + 0.002070833*t*t + 1.0/450000.0*t*t*t;
	*dF=0.0;
	*dE=0.0;
	for(i=0;i<106;i++){
		Arg=(Nut[i][0]*L+Nut[i][1]*Ld+Nut[i][2]*F+Nut[i][3]*D+Nut[i][4]*Omg)*pai;
		*dF=*dF+(Nut[i][6]+Nut[i][7]*t)/3600.0*1e-4*sin(Arg);
		*dE=*dE+(Nut[i][8]+Nut[i][9]*t)/3600.0*1e-4*cos(Arg);
		}
/*
	for(i=0;i<4;i++){
		Arg=(dNut[i][0]*L+dNut[i][1]*Ld+dNut[i][2]*F+dNut[i][3]*D+dNut[i][4]*Omg)*pai;
		*dF=*dF+(dNut[i][6]*sin(Arg)+dNut[i][7]*cos(Arg))/3600.0*1e-5;
		*dE=*dE+(dNut[i][8]*cos(Arg)+dNut[i][9]*sin(Arg))/3600.0*1e-5;
		}
*/
	*dF=*dF*pai;
	*dE=*dE*pai;

}

void Nutation (FILE *fp_Bin ,int DE, double jd, Matrix_3 *Nu)
{

    double E,E0,dE,dE0,dF,dF0,r[6];
	int nctr,ntarg,inside;

	nctr  = 12;
	/* Where does the ephemeris think things should be? */
	stcomm.km=FALSE_;/* AU & AU/Day*/
	stcomm.bary=TRUE_;/*Barycentre (Solar-sys. Barycentre)*/

	if(DE=406)	Nutation_data( jd,&dF, &dE);
	else{
	ntarg =  14;
	PLEPH(fp_Bin,jd,ntarg,nctr,r,&inside);
	dF = r[0];
	dE = r[1];
	}	
	dF0=dF;
	dE0=dE;

	E0 = Obl0_2000(jd)*pai;
	E  = E0 + dE;

	Matrix_R1(Nu1, - E, &Nu1);
	Matrix_R3(Nu2, -dF, &Nu2);
	Matrix_R1(Nu3, +E0, &Nu3);
	Multi_Matrix_3(Nu1,Nu2,&Nu4);
	Multi_Matrix_3(Nu4,Nu3,Nu);

}


void Precession_Data (double jd,Matrix_3 *Pr)
{
	double jd0,t,T, Zeta1,Zeta2,Zeta3,Theta1,Theta2,Theta3,Zed1,Zed2,Zed3;
	double Zeta,Zed,Theta;

	jd0=JD( 2000,1,1,12,0,0);

	T=(jd0-2451545.0)/36525.0;
	t=(jd-jd0)/36525.0;
	Zeta1  = 2306.2181 + 1.39656*T - 0.000139*T*T;
	Zeta2  = 0.30188 - 0.000344*T;
	Zeta3  = 0.017998;
	Theta1 = 2004.3109 - 0.85330*T - 0.000217*T*T;
	Theta2 = - ( 0.42665 + 0.000217*T);
	Theta3 = - 0.041833;
	Zed1   = 2306.2181 + 1.39656*T - 0.000139*T*T;
	Zed2   = 1.09468 + 0.000066*T;
	Zed3   = 0.018203;

	Zeta  = (  Zeta1*t +  Zeta2*t*t + Zeta3*t*t*t )/3600.0;
	Zed   = (   Zed1*t +   Zed2*t*t +  Zed3*t*t*t )/3600.0;
	Theta = ( Theta1*t + Theta2*t*t +Theta3*t*t*t )/3600.0;

	Matrix_R3(Pr1, - Zed*pai, &Pr1);
	Matrix_R2(Pr2, Theta*pai, &Pr2);
	Matrix_R3(Pr3, -Zeta*pai, &Pr3);
	Multi_Matrix_3(Pr1,Pr2,&Pr4);
	Multi_Matrix_3(Pr4,Pr3,Pr);

}

